<template>
  <div class="sankey">
    <l-map
      id="map"
      style="height: 80%; width: 100%"
      ref="map"
      :zoom="zoom"
      :center="center"
      @update:zoom="zoomUpdated"
      @update:center="centerUpdated"
      @update:bounds="boundsUpdated"
    >
      <l-tile-layer :url="url"></l-tile-layer>
    </l-map>
  </div>
</template>

<script>
import { LMap, LTileLayer } from 'vue2-leaflet'
import * as L from 'leaflet'
/* eslint-disable no-unused-vars */
import { spatialsankey } from 'd3-spatialsankey'
/* eslint-enable no-unused-vars */
import * as d3base from 'd3'
const d3 = Object.assign(d3base, { spatialsankey })
import { mapState } from 'vuex'


export default {
  name: 'Sankey',
  props: {
    filter: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      /* url: 'http://{s}.tile.osm.org/{z}/{x}/{y}.png', */
      /* url: 'https://stamen-tiles-{s}.a.ssl.fastly.net/watercolor/{z}/{x}/{y}.png', */
      url: 'https://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}{r}.png',
      svg: null,
      zoom: 3,
      center: [47.413220, -1.219482],
      bounds: null
    };
  },
  components: {
    LMap,
    LTileLayer
  },
  mounted: function () {
    this.setupSpatialSankey();
  },
  computed: {
    ...mapState(['isSelected'])
  },
  methods: {
    setIsSelected(isSelected) {
      this.$store.commit("setIsSelected", isSelected);
    },
    setSte(ste) {
      this.$store.commit("setSte", ste);
    },
    initializeSpatialSankey (nodes, links, codes) {
      // Setup svg element to work with
      var map = this.$refs.map.mapObject;
      L.svg().addTo(map);
      this.svg = d3.select("#map").select("svg");
      var linklayer = this.svg.append("g");
      var nodelayer = this.svg.append("g");

      // Load data asynchronosuly
      var setSte = this.setSte;
      var isSelected = () => this.isSelected;
      var toggleIsSelected = () => {
        this.setIsSelected(! this.isSelected);
        d3.event.stopPropagation();
      };
      map.on('click', () => {
        this.setIsSelected(false);
      });

      // Setup spatialsankey object
      var filter = this.filter;
      var filteredLinks = links.filter(function (link) {
        if (link.source in codes) {
          for (var key in filter) {
            console.log(codes[link.source][key], filter[key], link.source, key);
            if (codes[link.source][key] !== filter[key]) {
              return false;
            }
          }
          return true;
        }
      });
      var spatialsankey = d3.spatialsankey()
                              .lmap(map)
                              .nodes(nodes.features)
                              .links(filteredLinks);
      var options = {'use_arcs': false, 'flip': false};

      var linknodes = function(nodelinks, focus) {
        // Add data to link layer
        var beziers = linklayer.selectAll("path").data(nodelinks);
        var link = spatialsankey.link(options);

        // Draw new links
        var sankeyWidth = spatialsankey.link().width();
        beziers.enter()
          .append("path")
          .attr("d", link)
          .attr('id', function(d){return d.id})
          .style("stroke-width", function(d){return sankeyWidth(d);})
          .attr("pointer-events","visible")
          .style("pointer-events","visible")
          .on('mouseover', function(d){mouseover(d.source);})
          .on('click', toggleIsSelected)
          .on('mouseout', mouseout);

        if (focus) {
          beziers.style('opacity', function(d){return d.source == focus ? 1.0 : 0.1});
          beziers.style('stroke', function(d) {
            if (d.source == focus) {
              return 'rgba(255, 0, 0, 1)';
            }

            if (sankeyWidth(d) > 4) {
              return 'rgba(70, 200, 130, 1)';
            }

            if (sankeyWidth(d) > 2) {
              return 'rgba(70, 120, 130, 1)';
            }

            return 'rgba(100, 100, 100, 1)';
          });
        } else {
          beziers.style('opacity', 1.0);
          beziers.style('stroke', function(d) {
            if (sankeyWidth(d) > 4) {
              return 'rgba(70, 200, 130, 1)';
            }

            if (sankeyWidth(d) > 2) {
              return 'rgba(70, 120, 130, 1)';
            }

            return 'rgba(200, 200, 200, 1)';
          });
        }

        // Remove old links
        beziers.exit().remove();

        return beziers;
      };

      var mouseover = (source) => {
        if (! isSelected()) {
          // Get link data for this node
          var nodelinks = spatialsankey.links();

          linknodes(nodelinks, source);

          // Hide inactive nodes
          circs.transition().style('opacity',function () {
              return (this.id === source) ? 0.7 : 0;
          });

          setSte(source);
        }
      };

      var mouseout = () => {
        if (! isSelected()) {
          // Get link data for this node
          var nodelinks = spatialsankey.links();

          linknodes(nodelinks);
          // Remove links
          // linklayer.selectAll("path").remove();
          // Show all nodes
          circs.transition().style('opacity', 0.7);

          setSte("");
        }
      };

      // Draw nodes
      var node = spatialsankey.node({
        'mincolor': 'rgba(30, 40, 30, 0.3)',
        'maxcolor': 'rgba(30, 200, 100, 1)'
      });
      var circs = nodelayer.selectAll("circle")
        .data(spatialsankey.nodes())
        .enter()
        .append("circle")
        .attr('id', function(d){return d.id})
        .attr("cx", node.cx)
        .attr("cy", node.cy)
        .attr("r", node.r)
        .style("fill", node.fill)
        .attr("opacity", 0.7)
        .attr("pointer-events","visible")
        .on('mouseover', function(d){mouseover(d.id);})
        .on('click', toggleIsSelected)
        .on('mouseout', mouseout)

      var nodelinks = spatialsankey.links();
      linknodes(nodelinks);

      // Adopt size of drawn objects after leaflet zoom reset
      var zoomend = function(){
          linklayer.selectAll("path").attr("d", spatialsankey.link());

          circs.attr("cx", node.cx)
               .attr("cy", node.cy);
      };

      map.on("zoomend", zoomend);
    },
    setupSpatialSankey () {
      var init = this.initializeSpatialSankey;

      this.$store.dispatch('loadData').then(() => {
        var codes = this.$store.state.codes;
        var nodes = this.$store.state.nodes;
        var links = this.$store.state.links;

        if (! codes) {
          this.$store.dispatch('loadCodes').then(() => {
            init(nodes, links, this.$store.state.codes);
          });
        } else {
          init(nodes, links, codes);
        }
      });
    },
    zoomUpdated (zoom) {
      this.zoom = zoom;
    },
    centerUpdated (center) {
      this.center = center;
    },
    boundsUpdated (bounds) {
      this.bounds = bounds;
    }
  },
  watch: {
    filter: function () {
      var map = this.$refs.map.mapObject;
      map.removeLayer(this.svg);
      this.svg.remove();
      this.setupSpatialSankey();
    }
  }

}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #4283b9;
}
.sankey {
  height: 100%;
  width: 100%;
}
.sankey .vue2leaflet-map {
  min-height: 500px;
}
path {
  fill: none;
  stroke: #46B482;
  stroke-opacity: 0.6;
  stroke-linecap: round;
  cursor: pointer;
}
/*
path:hover {
  stroke-opacity: 0.8;
  stroke: #315B7E;
}
*/
</style>
